#include <math.h> 
#include <string.h>
#include "game.h"

volatile int t1;
int t2,t3, fts,fps=0;
int lives_left,current_level;
BITMAP *hud;

#define PA(x) (x->pa ? x->pa : x)
#define CL C[n_characs-1]
#define SOUND(A) play_sample((SAMPLE*)DD(A),255,128,1000,0)

enum { leftmove=0x1,  rightmove=0x2, upmove=0x4, downmove=0x8,
        firemove=0x10, jumpmove=0x20 };

extern V3D flag_v[17][9];
BITMAP *flag_bmp;
extern BITMAP *copy_buf;

/* smove (smooth move)
returns the acceleration used to get to position x1 with velocity v with maximum acceleration a */
#define Abs(n) (n<0 ? -(n) : n)
fix smove(fix x,fix v,fix a)
{
  fix d;
  if (Abs(x)<=a && Abs(v+x)<=a)
    return v+x;
  if (x<0) {
    d=v*Abs(v)+x*a*2;
    if (v<0 || d<-a*6) return -a;
    else if (d>a*6) return a;
    else return (fix)0;
  } else {
    d=v*v-x*a*2;
    if (v>0 || d<-a*4) return a;
    else if (d>0) return -a;
    else return (fix)0;
  }
}

struct Bits                    
{
  unsigned int n,i;
  Bits& operator- (int ii) { n=0; i=ii; return *this; }
  Bits& operator< (bool b) { if (b) n|=(1 << i); i++; return *this; }
}; Bits bits;

#define JS(a,b) joy[0].stick[0].axis[a].d##b
#define JS1(a,b) joy[1].stick[0].axis[a].d##b
#define JB(a) joy[0].button[a].b
#define JB1(a) joy[1].button[a].b
#define K(a) key[KEY_##a]

int get_input()
{
  int m1,m2;
  poll_joystick();
  bits - 0 < K(LEFT) < K(RIGHT) < K(UP) < K(DOWN) < false < (K(LCONTROL) || K(RCONTROL));
  m1=bits.n;
  bits - 0 < JS(0,1) < JS(0,2) < (JS(1,1) || JB(2)) < JS(1,2) < JB(1) < JB(0);
  m2=bits.n;
  return m1|m2;
}
#undef JS
#undef JB
#undef K

enum { K_PLAYER=1, K_BOSS, K_PROJECTILE, K_FLAG, K_TROLL, K_TOKEN };
enum { SK_HEAD=1, SK_HELMET, SK_PASS, SK_MISSILE, SK_CRAZY };

int n_characs,n_tokens,nn_tokens;
Charac C[MAX_CHARACS];

fix Charac::speed() { return sqrt(vx*vx+vy*vy); }

void Charac::init(int x,int y,int k)
{
  px=x; py=y;
  kind=k &0xff;
  vx=vy=0;
  pa=NULL;
  access=dead=face_l=false;
  go=sk=am=hit_ph=shot_ph=0;
  sp=1;
  switch (k & 0xff) {
    case K_PLAYER: w=14; h=30;
    Case K_TOKEN: w=h=13;
    Case K_TROLL: w=22; h=38; vy=-3.0;
    Case K_BOSS: w=33; h=85;
    Case K_FLAG: w=3; h=60;
    Case K_PROJECTILE: w=h=5;
  }
}

void add_charac(int x,int y,int k)
{
  C[n_characs].init(x,y,k);
  n_characs++;
}

unsigned char clapping[]= { 0xcf, 126, 0xb8, 7, 127, 0x9f, 62, 127 };
unsigned char stop_clapping[]= { 0x8f, 62, 0 };
int clap_t=0,togo;
             
void Charac::move()
{
#define LS ((int)(px - w))
#define RS ((int)(px + w))
#define US ((int)(py - h))
#define DS ((int)(py + h))

#define AT(x,y,at) (tile_attr[mapa(x,y)] & at)
#define AT1(at) AT(px/TILE_SIZE, py/TILE_SIZE, at)

  int tx, ty, div, j,j1;
  bool left, right, down, up;

  if (dead || (kind==K_PLAYER && togo && togo<190)) go=0;

  if (kind==K_PLAYER && map.a[px/TILE_SIZE][py/TILE_SIZE]==240) {
    if (!clap_t) {
      midi_out(clapping,8);
    }
    finish_t=t2;
    clap_t=200;
  }
  if (shot_ph) shot_ph--;
  if (hit_ph) hit_ph--;

  if (kind==K_PROJECTILE) {
    if (px<0 || px>TILE_SIZE*map.w || py<0 || py>TILE_SIZE*map.h) kind=0;
    vy+=0.25; //gravity
  } else {

    vx=0;
    if (go & leftmove) { vx-=5.1; face_l=true; }
    if (go & rightmove) { vx+=5.1; face_l=false; }
    if (go & (leftmove|rightmove)) (++walk_ph)%=32;
    else walk_ph=0;

    if (kind==K_PLAYER || kind==K_BOSS) {
      if (py>(map.h+2)*TILE_SIZE && !dead) {
        dead=true; togo=150;
      }
    }
    if (kind==K_PLAYER) {
      vy+=0.25; // gravity
        down=true;
        for (tx = LS/TILE_SIZE; tx <= (RS-1)/TILE_SIZE; tx++)
          if(AT(tx, (DS)/TILE_SIZE, ATTR_SOLID_TOP))
            down = false;
      if (go & ~old_go & jumpmove && !down)  vy=-8.1;
    }
    if (kind==K_TROLL || kind==K_BOSS) {
      up=down=true;
      for (tx = LS/TILE_SIZE; tx <= (RS-1)/TILE_SIZE; tx++) {
        if(AT(tx, (DS)/TILE_SIZE, ATTR_SOLID_TOP))  down = false;
        if (AT(tx, (US-1)/TILE_SIZE, ATTR_SOLID_LRB))  up = false;
      }
      if (go & upmove && !down) vy= (kind==K_TROLL) ? -2 : -4.5;
      else if (go & downmove && !up) vy= (kind==K_TROLL) ? 8.0 : 14.0;
      else if (go & upmove) vy-=0.1; else vy+=0.25;
    }
  }

  up = left = right = down = true;

  div=sqrt(vx*vx+vy*vy)+1;

  for (j=0;j<div;j++) {

    if (kind!=K_PROJECTILE) {

      for (ty = US/TILE_SIZE; ty <= (DS-1)/TILE_SIZE; ty++)
        if (AT((LS-1)/TILE_SIZE, ty, ATTR_SOLID_LRB))
          left = false; 

      for (ty = US/TILE_SIZE; ty <= (DS-1)/TILE_SIZE; ty++)
        if (AT((RS)/TILE_SIZE, ty, ATTR_SOLID_LRB))
          right = false; 

      for (tx = LS/TILE_SIZE; tx <= (RS-1)/TILE_SIZE; tx++)
        if(AT(tx, (US-1)/TILE_SIZE, ATTR_SOLID_LRB))
          up = false;

      for (tx = LS/TILE_SIZE; tx <= (RS-1)/TILE_SIZE; tx++)
        if(AT(tx, (DS)/TILE_SIZE, ATTR_SOLID_TOP))
          down = false;
    }

    if(vy < 0) {
      if (up)  py += vy/div;
      else vy=0;
    }
    if(vy > 0) {
      if (down) py += vy/div;
      else {
        if (kind==K_TROLL) {} //
        if (kind==K_BOSS && vy>10) {
          SOUND(HIT);
          ty=(DS)/TILE_SIZE;
          for (j1=0;j1<85;j1++) {
            tx=(LS+RS+j1*(j1&1?1:-1))/TILE_SIZE/2;
            if(AT(tx, ty, ATTR_SOLID_TOP)) break;
          }
          map.a[tx][ty]=1;
          calc_tile(tx,ty);
          calc_tile(tx,ty-1);
        } 
        vy=0;
      }
    }
    if(vx < 0) {
      if (left) px += vx/div;
      else vx=0;
    }
    if(vx > 0) {
      if (right) px += vx/div;
      else vx=0;
    }
  }
  return;
#undef US
#undef DS
#undef LS
#undef RS
}

void Charac::think()
{
  if (kind==K_TROLL) {
    go= vy>0.3 ? 0:upmove;
    if (ABS(px-C[0].px)<60) go |= downmove;
  }
  if (kind==K_BOSS) {
//    bits - 0 < key[KEY_A] < key[KEY_D] < key[KEY_W] < key[KEY_S];
//    go=bits.n;
    go=0;
    if (vy<-0.3 || py<200) {
      if (C[0].px>px) go|=rightmove;
      if (C[0].px<px) go|=leftmove;
    }
    if (t2%400==313) go|=downmove;
    if (t2%400<200) go|=upmove;

  }
}

void Charac::draw()
{
#define DS draw_sprite(buf,b,px-OX-b->w/2,py-OY-b->h/2)
#define DSS(W,H) stretch_sprite(buf,b,px-OX-W/2,py-OY-H/2,W,H)
#define DSH draw_sprite_h_flip(buf,b,px-OX-b->w/2,py-OY-b->h/2)
#define RSS  rotate_scaled_sprite(buf,b,px-OX-b->w/2,py-OY-b->h/2,ftofix(64-th),ftofix(1.0))
#define RSSF if (USA) RSS; \
    else rotate_scaled_sprite_v_flip(buf,b,px-OX-b->w/2,py-OY-b->h/2,ftofix(-64-th),ftofix(1.0))
  BITMAP *b=NULL; int sn;
  
  switch(kind) {
    case K_PLAYER:
      if (dead) sn=A11;
      else if (togo && togo<40) sn=A12;
      else if (togo && togo<190) sn=A01;
      else if (vy<-0.1) sn = face_l ? A14 : A13;
      else if (vy>0.3 || (walk_ph>16 && walk_ph<26)) sn = face_l ? A06 : A02;
      else if (walk_ph>0 && walk_ph<10) sn = face_l ? A05 : A03;
      else sn = face_l ? A10: A04;
      b=BD(sn); DS;
    Case K_TROLL:    b=BD(B1); DS;
    Case K_BOSS: b=BD(B2); DS;
    Case K_TOKEN:   b=BD(H4); DS;
    Case K_PROJECTILE: b=BD(sk==SK_HEAD ?H1 :H2); DSS(20,25);

    Case K_FLAG:
     rectfill(buf,px-OX-3,py-OY-75,px-OX+2,py-OY+74,col_grey);
     rectfill(buf,px-OX-13,py-OY+71,px-OX+12,py-OY+74,col_grey);
     if (face_l) {
      int x,y; float th;
      for (x=0;x<17;x++) {
        for (y=0;y<9;y++) {
          th=t2/12.0+x/5.0;
          V3D &v1=flag_v[x][y];
          v1.x=ftofix(px-OX+8*x);
          v1.y=ftofix(py-OY+ (togo>240 ? (togo-240)*(150-64)/100-75:-75) +8*y-x*0.6*sin(th));
          v1.u=itofix(x*10);
          v1.v=itofix(y*10);
          v1.c=(int)(205+50*cos(th)-2.2*y);
        }
      }
      for (x=0;x<16;x++)
        for (y=0;y<8;y++)
          quad3d(buf,POLYTYPE_ATEX_LIT,flag_bmp,&flag_v[x][y],&flag_v[x+1][y],&flag_v[x+1][y+1],&flag_v[x][y+1]);
    }
    Default: return;
  }

  if (!b) return;
#undef DS
#undef RSS
#undef RSSF
}

void eq_bounce(Charac *p1, Charac *p2)
{
  // Here's some physics! Make the objects bounce each other away
  fix px,py,vx,vy,a,vn;
  px=p2->px-p1->px;
  py=p2->py-p1->py;
  vx=p2->vx-p1->vx;
  vy=p2->vy-p1->vy;
  if (px*px+py*py<1) return;
  a=atan2(py,px);
  vn=vx*cos(a)+vy*sin(a);
  if (vn<0) {
    p1->vx+=vn*cos(a);
    p1->vy+=vn*sin(a);
    p2->vx-=vn*cos(a);
    p2->vy-=vn*sin(a);
  }
}

void uneq_bounce(Charac *p1, Charac *p2)
{
  fix px,py,vx,vy,a,vn;
  px=p2->px-p1->px;
  py=p2->py-p1->py;
  vx=p2->vx-p1->vx;
  vy=p2->vy-p1->vy;
  if (px*px+py*py<1) return;
  a=atan2(py,px);
  vn=vx*cos(a)+vy*sin(a);
  if (vn<0) {
    p2->vx-=1.5*vn*cos(a);
    p2->vy-=1.5*vn*sin(a);
  }
}

void grab(Charac *p1, Charac *p2)
{
  p2->kind=0;
  SOUND(GET);
}

void grant_access()
{
  int x,y;
  for (x=0;x<map.w;x++)
    for (y=0;y<map.h;y++)
      if (map.a[x][y]==106)
        map.a[x][y]=1;
  for (x=0;x<map.w;x++)
    for (y=0;y<map.h;y++)
      calc_tile(x,y);
}

void kill(Charac *p)
{
  togo=150;
  p->dead=true; p->vx=0;

//  play_sample((SAMPLE*)DD(DIE),255,128,500,0);

  add_charac(p->px,p->py-20,K_PROJECTILE);
  CL.sk=SK_HEAD;
  CL.vx=0.07*(50-rand()%100);
  CL.vy=-8+0.04*(50-rand()%100);

  add_charac(p->px,p->py-20,K_PROJECTILE);
  CL.sk=SK_HELMET;
  CL.vx=0.07*(50-rand()%100);
  CL.vy=-8+0.04*(50-rand()%100);
}

bool two_body(Charac *p1, Charac *p2)
{
  int k1,k2;

  if (ABS(p1->px-p2->px) < p1->w+p2->w && ABS(p1->py-p2->py) < p1->h+p2->h) {
    k1=p1->kind;
    k2=p2->kind;

    if (k1>k2) return two_body(p2,p1);

    switch(k1*10+k2) {
      case 11: case 44: case 55: case 56: case 66: eq_bounce(p1,p2);
      Case 16: grab(p1,p2); if (!--n_tokens) grant_access();
      Case 14: if (!togo) {
        togo=340; p2->face_l=true;
        play_midi((MIDI*)DD(M1),FALSE);
        k1=rand()%4;
        if (k1==3) flag_bmp=copy_buf; else flag_bmp=BD(F2+k1);
      }
      Case 15: case 12: if (!p1->dead) kill(p1);
    }
  }
  return false;
}

#define X (map.i[j].x)
#define Y (map.i[j].y)
#define N (map.i[j].n)

bool produce_cast()
{
  int j;
  n_characs=n_tokens=0;
  for (j=0;j<map.n_ins;j++)
    if (N == 11)
      add_charac(X,Y,K_PLAYER);
  if (!n_characs) {
//    fprintf(fr,"No entry code %d found\n",entry);
    return false;
  }

  for (j=0;j<map.n_ins;j++) {
    switch (N/10) {
      case 3:
        if ((N%10)==9) add_charac(X,Y,K_BOSS);
        else add_charac(X,Y,K_TROLL);
      Case 2:
        add_charac(X,Y,K_FLAG);
        CL.th=(N%10)*25;
        if (N%10==5) CL.sk=5;
      Case 4: 
        add_charac(X,Y,K_TOKEN);
        n_tokens++;
        CL.th=(N%10)*25;
        if (N%10==5) CL.sk=5;
    }
    nn_tokens=n_tokens;

  }
  return true;
}


void timer_click()
{ t1++; }
END_OF_FUNCTION(timer_click);


static void cleanup()
{
  if (clap_t) {
    midi_out(stop_clapping,3);
    clap_t=0;
  }
  while (keypressed()) readkey();
  n_characs=0;
}

void thickline(BITMAP *b,int x1,int y1,int x2,int y2,int c)
{
  line(b,x1-1,y1,x2-1,y2,c);
  line(b,x1-1,y1-1,x2-1,y2-1,c);
  line(b,x1,y1,x2,y2,c);
  line(b,x1,y1-1,x2,y2-1,c);
}

void draw()
{
  int j,w=SCREEN_W,h=SCREEN_H;

  BITMAP *b = BD(current_level%4 ? C0:C2);
  blit(b,buf,OX ? (b->w-w)*OX/(TILE_SIZE*map.w-w) :0,
                   OY ? (b->h-h)*OY/(TILE_SIZE*map.h-h) :0,0,0,w,h);
  
  draw_tiles();

  for (j=n_characs-1;j>=0;j--)
    C[j].draw();

  textprintf_ex(buf,FD,20+1,10+1,col_white,-1,"Level %d", current_level);
  textprintf_ex(buf,FD,20,10,col_black,-1,"Level %d", current_level);

  textprintf_right_ex(buf,FD,SCREEN_W-10,11,col_white,-1,"Tokens: %d/%d",
      nn_tokens-n_tokens,nn_tokens);
  textprintf_right_ex(buf,FD,SCREEN_W-11,10,col_black,-1,"Tokens: %d/%d",
      nn_tokens-n_tokens,nn_tokens);

  if (C[0].dead && !lives_left) 
    textprintf_centre_ex(buf,FD,SCREEN_W/2,SCREEN_H/2-10,col_white,col_red,"GAME OVER");

  for (j=0; j<lives_left; j++) {
    stretch_sprite(buf,BD(H1),300+35*j,30,25,30);
  }
}

int play_map()
{
  char fn[20];
  int i,j,x,y;
  t1=1; t2=0; togo=0;

  play_midi((MIDI*)DD(current_level&1 ? M2 : M3),TRUE);

  sprintf(fn,"m%02d.map",current_level); 
  load_map(fn);
  if (!produce_cast()) {
//    fprintf(2,"Produce cast failed\n");
    cleanup();
    return -1;
  }

  for (x=20; x<map.w*TILE_SIZE-20; x+=30) {
    for (y=20; y<map.h*TILE_SIZE-20; y+=30) {
      i=rand()%5000;
      // in case we want to add pikups at random
    }
  }

  while(!key[KEY_ESC]) {

    if (t1<=t2) {
      int w=SCREEN_W,h=SCREEN_H,hw=w/2,hh=h/2;

      OX=MID(0,map.w*TILE_SIZE-w,(int)C[0].px-hw);
      OY=MID(0,map.h*TILE_SIZE-h,(int)C[0].py-hh);
      draw();
      blit(buf,screen,0,0,0,0,w,h);
      stretch_blit(buf,copy_buf,0,0,w,h,0,0,160,80);

      fts++;

     } else {

      if (clap_t) {
        clap_t--;
        if (!clap_t) {
          midi_out(stop_clapping,3);
        }
      }
#ifdef CHEAT
      if (key[KEY_F12]) togo=20;
#endif
      if (togo) {
        if (!--togo) {
          if (C[0].dead) return -1;
          else return 1;
        }
      }
      for (j=0;j<n_characs;j++) {
        C[j].think();
      }
      j=get_input();
      C[0].old_go=C[0].go;
      C[0].go=j;

      for (j=0;j<n_characs;j++)
        C[j].move();

      for (i=0;i<n_characs && i<40;i++)
        for (j=i+1;j<n_characs;j++)
          two_body(&C[i],&C[j]);
 
      t2++;
      if (!(t2%timer_speed)) { fps=fts; fts=0; }
    }
  }
  cleanup();
  return -2;
}

void play_game()
{
  int r,n;
  lives_left=4;
  n=count_maps();
  current_level=1;
  while (current_level<=n) {
    r=play_map();
    if (r>0) current_level++;
    else if (r==-1) lives_left--;
    if (r==-2) break;
    if (lives_left<0) break;
  }
  if (current_level>n) {
    play_midi((MIDI*)DD(M4),0);
    clear_to_color(buf,col_green);
    textout_centre_ex(buf,FD,"Well done! You finished the game.",320,40,col_black,-1);
    draw_sprite(buf,BD(H3),278,70);
    textout_centre_ex(buf,FD,"This game was made for TINS 2005",320,230,col_blue,-1);
    blit(BD(F2),buf,0,0, 40,370,160,80);
    blit(BD(F3),buf,0,0,240,370,160,80);
    blit(BD(F4),buf,0,0,440,370,160,80);
    blit(buf,screen,0,0,0,0,SCREEN_W,SCREEN_H);
    while (keypressed()) readkey();
    readkey();
    exit(0);
  }
}

