# Makefile for TINS entry

# Most things here are for me to change, but anyone else may need to change things, eg the "g++" if your compiler is named differently.

# Should be 0 or 1
DEBUG = 0
# Should be Full, NoSrc, Entry, Regular
ZIPTYPE = Entry

# Put this in to redirect errors
ER = redir -e errors.txt

SRC = *.cpp *.h makef* obj obj_d
ALWAYSIN = *.dat *.map *.qk readme.txt log.txt  *.htm
RAW = *.wav *.bmp
# Change this if you have a different compiler
C = g++

d_exe = a.exe
r_exe = game.exe

ifeq ($(DEBUG),1)
LIBS = -lm -lalld
CFLAGS = -Wall -g -DERIC_ALLEGRO -DCHEAT
EXE = $(d_exe)
obj_dir = obj_d/
else
LIBS = -lm -lalleg
CFLAGS = -Wall -DERIC_ALLEGRO
EXE = $(r_exe)
obj_dir = obj/
endif

ifeq ($(ZIPTYPE),Full)
INZIP = $(ALWAYSIN) $(RAW) $(SRC)
endif
ifeq ($(DEBUG),0)
ifeq ($(ZIPTYPE),NoSrc)
INZIP = $(ALWAYSIN) $(EXE)
endif
ifeq ($(ZIPTYPE),Regular)
INZIP = $(ALWAYSIN) $(EXE) $(SRC)
endif
endif
ifeq ($(ZIPTYPE),Entry)
INZIP = $(ALWAYSIN) $(SRC)
endif

OBJS1 = share.o game.o maped.o menu.o

OBJS = $(addprefix $(obj_dir),$(OBJS1))

normal: $(EXE)

$(EXE): $(OBJS)
	$C -o $@ $(OBJS) $(LIBS)


$(obj_dir)%.o: %.cpp
	$C -c $(CFLAGS) $< -o $@


# Make clean is needed if any .h files are changed.
clean:
	rm -f *.o */*.o $(r_exe) $(d_exe)
#	touch -t 090513131998 $(DATA1)

ifdef INZIP
zip: $(INZIP)
	rm -f lego.zip
	7z a -tzip lego.zip $(INZIP)
else
zip:
	rem INZIP is undefined. Check that WHICHZIP and DEBUG are correctly specified.
endif
