#include "menu.h"

FONT *menu_font=font;

  void NumChanger::OnUp()
  {  if (*p<max) (*p)++; }
  void NumChanger::OnDown()
  { if (*p>min) (*p)--; }

 // MenuItem class

  MenuItem::MenuItem()
  { list=NULL; kind=0; ret=0; }

  MenuItem::MenuItem(string n, int i)
  { list=NULL; name=n; ret=i; kind=1; }

  MenuItem::MenuItem(int k,string n, int i)
  { list=NULL; name=n; ret=i; kind=k; }

  MenuItem::MenuItem(string n,MenuList *l)
  { kind=5; list=l; name=n; }

  MenuItem::MenuItem(MenuList *l,string n)
  { kind=4; list=l; name=n; }

  MenuItem::MenuItem(string n, int *p,int min,int max)
  { kind=2; name=n;
    num=new NumChanger;
    num->p=p; num->min=min; num->max=max;
  }

  MenuItem::MenuItem(string n,bool *p)
  { name=n; b_ptr=p; kind=3; list=NULL; }

  string MenuItem::Rhs()
  {
    string s;
    if (kind==2) { s+=(char)48+*(num->p)/10; s+=(char)48+*(num->p)%10; }
    if (kind==3) s=(*b_ptr ? "On" : "Off" );
    if (kind==4) s=" ";
    if (kind==5) s=list->a[list->index]->name;
    return s;
  }


// MenuList class

  MenuList::MenuList()
  {
    size=0;
    index=0;
  }

  void MenuList::Add(MenuItem *m)
  {
    int w=30+text_length(menu_font,m->name.c_str());
    if (!size) {
      m->y=0;
      width=w;
    } else {
      if (width<w) width=w;
      m->y=a[size-1]->y + (text_height(menu_font)*11/10+2) ;
    }
    a.push_back(m);
    size++;
  }
  
  void MenuList::Add(MenuItem &m)
  { Add(&m); }

  MenuList& MenuList::operator<< (MenuItem &m)
  { Add(m); return *this; }
  MenuList& MenuList::operator<< (MenuItem *m)
  { Add(m); return *this; }

  void MenuList::OnUp()
  {  if (index>0) index--;  }

  void MenuList::OnDown()
  { if (index<size-1) index++; }


// MenuSet class

  MenuSet::MenuSet(MenuList *l)
  {
    lc=l; ic=l->a[l->index];
    nc=NULL;
    a.push_back(l);
    active=0;

    l->x=30; l->oy=20;
  }

  void MenuSet::Draw(BITMAP *bmp)
  {
    int j,k; char s_num[6];
    for (j=0; j<(int)a.size(); j++)
    {
      MenuList *l=a[j];
      MenuItem *m=l->a[l->index];

      if (l->oy+m->y > bmp->h-20) l->oy = bmp->h-20-m->y;
      if (l->oy+m->y < 20) l->oy = 20-m->y;

      vline(bmp,l->x, l->oy, l->oy+l->a[l->size-1]->y,linecol);
      for (k=0; k<l->size; k++)
      {
        m=l->a[k];
        hline(bmp,l->x, l->oy+m->y, l->x+10, linecol);
        textout_ex(bmp,menu_font,m->name.c_str(), l->x+15, l->oy+m->y-text_height(menu_font)/2, l->index==k ? wordcol1 : wordcol0, l->index==k && active==j ? hilightcol : -1);
        if (j==(int)a.size()-1)
        { 
          string s;
          if (m->kind==2) { sprintf(s_num,"%d",*(m->num->p)); s=s_num; }
          if (m->kind==3) s=(*(m->b_ptr) ? "On" : "Off" );
          if (m->kind==4) s=" ";
          if (m->kind==5) s=m->list->a[m->list->index]->name;
          if (!s.empty())
          {
            hline(bmp,l->x+20+text_length(menu_font,m->name.c_str()), l->oy+m->y, l->x+l->width+0, linecol);
            textout_ex(bmp,menu_font,s.c_str(), l->x+5+l->width, l->oy+m->y-text_height(menu_font)/2, l->index==k ? wordcol1 : wordcol0, l->index==k && (active==j+1 || m->kind==3) ? hilightcol : -1);
          }
        }
      }
      if (j<(int)a.size()-1)
      {
        m=l->a[l->index];
        hline(bmp,l->x+20+text_length(menu_font,m->name.c_str()), l->oy+m->y, l->x+l->width, linecol);
      }
    }
  }

  void MenuSet::Pop()
  {
    if (active==(int)a.size()-1) a.pop_back();
    active--;
    // here we'll need to change all the x values
  }

  void MenuSet::Push(MenuList *l)
  {
    if (!l->size) return;
    a.push_back(l);
    active++;
    l->x=lc->x+lc->width;
    l->oy=lc->oy+ic->y;
  }

  int MenuSet::OnKey(int c)
  {
    int ch=c>>8;

    if (ch==KEY_LEFT)
    {
      if (active) Pop();
    }
    if (ch==KEY_RIGHT)
    {
      if (nc) return 0;
      if (ic->kind==4 || ic->kind==5) Push(ic->list);
      if (ic->kind==2) active++;
    }
    if (ch==KEY_UP)
    {
      if (nc) nc->OnUp();
      else a[active]->OnUp();
    }
    if (ch==KEY_DOWN)
    {
      if (nc) nc->OnDown();
      else a[active]->OnDown();
    }
    if (ch==KEY_ENTER)
    {
      if (nc) Pop();
      else if (ic->kind==2) active++; 
      if (ic->kind==1) return ic->ret;
      if (ic->kind==3) *(ic->b_ptr)=!*(ic->b_ptr);
      if (ic->kind==4 || ic->kind==5) Push(ic->list);
    }
    if (ch==KEY_ESC)
    {
      if (active) Pop();
      else if (ic->ret==-1) return -1;
      else lc->index=lc->size-1;
    }
    nc=NULL;
    if (active<(int)a.size()) lc=a[active];
    else if (ic->kind==2) nc=ic->num;
    ic=lc->a[lc->index];
    return 0;
  }

#ifdef MENU_MAIN

int main()
{
  MenuList ml,ml1,ml2;
  int ANum=8;
  bool ABool=false;

  MenuItem i11("Black",1), i12("Red",2), i13("Blue",3);
  ml1 << i11 << i12 << i13;

  MenuItem i21("Blue",0), i22("Green",0), i23("Purple",0);
  ml2 << i21 << i22 << i23;

  MenuItem i2("Word colour",&ml2), i3(&ml1,"Line colour"), i5("Number",&ANum,2,11), i4("Quit",-1), i6("Toggle",&ABool);
  ml << i2 << i3 << i5 << i6 << i4;

  MenuSet ms(&ml);

  allegro_init();
  install_keyboard();
  set_color_depth(8);
  set_gfx_mode(GFX_SAFE,320,200,0,0);

  ms.linecol=0;
  ms.wordcol0=1;
  ms.wordcol1=9;
  ms.wordcol2=0;
  ms.hilightcol=15;

  BITMAP*buffer=create_bitmap(SCREEN_W,SCREEN_H);
  int k,r;

  do {
    clear_to_color(buffer,15);
    ms.Draw(buffer);
    blit(buffer,screen,0,0,0,0,SCREEN_W,SCREEN_H);

    k=readkey();
    r=ms.OnKey(k);

    if (r==1) ms.linecol=0;
    if (r==2) ms.linecol=4;
    if (r==3) ms.linecol=1;
    if (ml2.index==0) {ms.wordcol0=1; ms.wordcol1=9; }
    if (ml2.index==1) {ms.wordcol0=2; ms.wordcol1=10; }
    if (ml2.index==2) {ms.wordcol0=5; ms.wordcol1=13; }
  } while (r!=-1);

  return 0;
}
#endif
