#ifndef MENU_H
#define MENU_H

#include <string>
#include <vector>
using namespace std;
#include <allegro.h>

extern FONT *menu_font;

struct NumChanger;
struct MenuItem;
struct MenuList;

struct NumChanger
{
  int *p,min,max;

  void OnUp();
  void OnDown();
};

struct MenuItem
{
  int kind; // 1=node, 2=number, 3=bool, 4=submenu, 5=list of choices
  MenuList *list;
  string name;
  int y,ret;
  bool *b_ptr;
  NumChanger *num;

  MenuItem();                                 // nothing
  MenuItem(string n, int i);                  // node
  MenuItem(int k,string n, int i);            // k=kind
  MenuItem(string n,MenuList *l);             // list of choices
  MenuItem(MenuList *l,string n);             // submenu
  MenuItem(string n, int *p,int min,int max); // number
  MenuItem(string n,bool *p);                 // bool

  string Rhs();
};

struct MenuList
{
  vector <MenuItem*> a;
  int size,oy,x,index,width,length,height;

  MenuList();

  void Add(MenuItem *m);
  void Add(MenuItem &m);

  MenuList& operator<< (MenuItem &m);
  MenuList& operator<< (MenuItem *m);

  void OnUp();
  void OnDown();
};

struct MenuSet
{
  vector <MenuList*> a;
  int active;
  MenuList *lc; // current MenuList
  MenuItem *ic; // current MenuItem
  NumChanger *nc; // current NumChanger (if there is one)
  int linecol, wordcol0, wordcol1, wordcol2, hilightcol;

  MenuSet();
  MenuSet(MenuList *l);

  void Draw(BITMAP *bmp);

  void Pop();
  void Push(MenuList *l);

  int OnKey(int c);
};
#endif
