#ifndef SHARE_H
#define SHARE_H

#include <allegro.h>
#include "macro.h"
#include "data.h"

#define DD(n) (D[(n)].dat)
#define BD(n) ((BITMAP*)DD(n))
#define FD ((FONT*)DD(FONT1))

#define THE_COLOURS int col_red, col_blue, col_white, col_green, col_black, col_yellow, col_cyan, col_magenta, col_grey, col_gold;

#define timer_speed 50

extern THE_COLOURS

extern volatile int t1;
extern int OX,OY,t2;
extern PALETTE pal;
extern BITMAP *buf;

void set_gfx1();
void set_gfx2();
void place_screen();

void share_init();

void draw_tile(int x,int y);
void draw_tiles();
int mapa(int,int);

#define BT(n) ((BITMAP*)D[TILE000+((n)&127)].dat) // half the tiles

#define TILE_SIZE 32

#define MAX_MAP_X 256
#define MAX_MAP_Y 256
#define MAX_INS 256

#define ATTR_SOLID_TOP 1
#define ATTR_SOLID_LRB 2
#define ATTR_LADDER    4
#define ATTR_DOOR      8
#define ATTR_HURT     16

typedef struct
{
  int x,y,n;
} Insertion;

extern uchar tile_attr[];

typedef struct
{
  int w,h,n_ins;
  uchar a[MAX_MAP_X][MAX_MAP_Y],
        b[MAX_MAP_X][MAX_MAP_Y],
      ori[MAX_MAP_X][MAX_MAP_Y];
  Insertion i[MAX_INS];
} Map;

extern Map map;

extern DATAFILE *D;

void tiles_init();

void insert_row(int ty);
void delete_row(int ty);
void insert_column(int tx);
void delete_column(int tx);
void calc_tile(int x,int y);

int count_maps();
void save_map(char *fn);
void load_map(char *fn);

void play_game();
void maped_main(char *fn);

void timer_click();
void timer_click_end();


#endif
